import { Server } from 'socket.io'
import { TSocket, ExtendedCharacter } from '../../utilities/Types'
import CharacterRepository from '../../repositories/CharacterRepository'

type SocketResponseT = {
  character_id: number
}

export default function (socket: TSocket, io: Server) {
  socket.on('character:connect', async (data: SocketResponseT) => {
    console.log('character:connect requested', data)
    try {
      socket.character = (await CharacterRepository.getByUserAndId(socket.user?.id as number, data.character_id)) as ExtendedCharacter
      socket.emit('character:connect', socket.character)
    } catch (error: any) {
      console.log('character:connect error', error)
    }
  })
}
